/* Copyright (C) 1979-1996 TcX AB & Monty Program KB & Detron HB

   This software is distributed with NO WARRANTY OF ANY KIND.  No author or
   distributor accepts any responsibility for the consequences of using it, or
   for whether it serves any particular purpose or works at all, unless he or
   she says so in writing.  Refer to the Free Public License (the "License")
   for full details.
   Every copy of this file must include a copy of the License, normally in a
   plain ASCII text file named PUBLIC.	The License grants you the right to
   copy, modify and redistribute this file, but only under certain conditions
   described in the License.  Among other things, the License requires that
   the copyright notice and this notice be preserved on all copies. */

/* close a heap-database */

#include "heapdef.h"

	/* Close a database open by hp_open() */
	/* Data is not deallocated */

int heap_close(HP_INFO *info)
{
  int tmp;
  DBUG_ENTER("heap_close");
  pthread_mutex_lock(&THR_LOCK_heap);
  tmp= _hp_close(info);
  pthread_mutex_unlock(&THR_LOCK_heap);
  DBUG_RETURN(0);
}


int _hp_close(register HP_INFO *info)
{
  int error=0;
  DBUG_ENTER("_hp_close");
#ifndef DBUG_OFF
  if (info->s->changed && heap_check_heap(info))
  {
    my_errno=HA_ERR_CRASHED;
    error=1;
  }
#endif
  info->s->changed=0;
  info->s->open_count--;
  heap_open_list=list_delete(heap_open_list,&info->open_list);
  my_free((gptr) info,MYF(0));
  DBUG_RETURN(error);
}

